package es3;
import java.util.ArrayList;

public class Carrello {
	private final String nome;
	private final ArrayList<Prodotto> prodotti;
	private final ArrayList<Integer> quantita;
	
	public Carrello (String nome) {
		this.nome=nome;
		prodotti = new ArrayList<>();
		quantita = new ArrayList<>();
	}
	
	public String getNome() {
		return nome;
	}
	
	public void addProdotto(Prodotto p, int n) {
		if (p==null || n<1) return;
		
		//soluzione 1 (ricerca manuale):
		boolean trovato=false;
		for (int i = 0; i< prodotti.size() && !trovato; i++) {
			if (prodotti.get(i).equals(p)) {
				quantita.set(i, n + quantita.get(i)); // quantita[i]=n+quantita[i]
				trovato=true;
			}
		}
		if (!trovato) {
			prodotti.add(p);
			quantita.add(n);
		}

		/*
		//soluzione 2 (sfruttando indexOf)
		int ricerca= prodotti.indexOf(p);
		
		if (ricerca>=0) {
			quantita.set(ricerca, n + quantita.get(ricerca));
		} else {
			prodotti.add(p);
			quantita.add(n);
		}
		*/	
	}
	
	public float getTotale () {
		int totale=0;
		for (int i=0; i<prodotti.size(); i++) {
			totale += prodotti.get(i).getPrezzoUnitario() * 
					  quantita.get(i);
		}
		return ((float)totale)/100;		
	}
	
}
