package es6;
import java.util.ArrayList;

public class Magazzino {
	private final ArrayList<Articolo> articoli;
	
	public Magazzino() {
		articoli = new ArrayList<>();
	}
	
	public boolean vuoto() {
		return articoli.size()==0;
	}
	
	/* 
	 * assumo che uno stesso articolo compaia SOLO UNA VOLTA
	 * nell'arrayList articoli (con la opportuna giacenza) 
	 */
	public double valore (String codice) {
		for (Articolo a:articoli) {
			if (codice.equals(a.getCodice())) {
				return a.getGiacenza()*a.getPrezzoUnitario();
			}
		}
		return 0;
	}
	
	public double valore() {
		double totale=0;
		for (Articolo a:articoli) {
			totale += a.getGiacenza()*a.getPrezzoUnitario();
		}
		return totale;
	}
	
	public ArrayList<Articolo> daAcquistare(){
		ArrayList<Articolo> aArticoli=new ArrayList<>();
		for (Articolo a:articoli) {
		    if (a.getGiacenza()<a.getMin()) {
		    	aArticoli.add(a);
		    }
		}
		return aArticoli;
	}
	
	public double costo (String codice) {
		for (Articolo a:articoli) {
			if (codice.equals(a.getCodice())) {
				int mancante= a.getMin() - a.getGiacenza();
				if (mancante<=0) {
					return 0.0;
				} else {
					return mancante*a.getPrezzoUnitario();
				}
			}
		}
		return 0;
	}
	
	public double costo() {
		double totale=0;
		for (Articolo a:articoli) {
			int mancante= a.getMin() - a.getGiacenza();
			if (mancante>0) {
				totale += mancante*a.getPrezzoUnitario();
			}
		}
		return totale;
	}
	
	public boolean controlloMagazzino() throws MagazzinoException {
		for (Articolo a:articoli) {
			int mancante= a.getMin() - a.getGiacenza();
			if (mancante>0) {
				throw new MagazzinoException();
			}
		}
		return true;
	}
	
}
